/* LICENSE:
  =========================================================================
    CMPack'04 Source Code Release for OPEN-R SDK 1.1.5-r2 for ERS7
    Copyright (C) 2004 Multirobot Lab [Project Head: Manuela Veloso]
    School of Computer Science, Carnegie Mellon University
    All rights reserved.
  ========================================================================= */

#ifndef __GVECTOR_GEOMETRY_H__
#define __GVECTOR_GEOMETRY_H__

#include "gvector.h"

typedef GVector::vector3d<double> vector3d;
typedef vector3d point3d;

typedef GVector::vector2d<double> vector2d;
typedef vector2d point2d;

// Use with extreme caution, many calculation do not work
// correctly with integers
typedef GVector::vector2d<int> vector2i;
typedef vector2i point2i;

typedef GVector::vector3d<float> vector3f;
typedef vector3f point3f;

typedef GVector::vector2d<float> vector2f;
typedef vector2f point2f;

inline vector2f vec2d2f(vector2d v) {return(vector2f(v.x,v.y));}
inline vector2d vec2f2d(vector2f v) {return(vector2d(v.x,v.y));}

#endif
// __GVECTOR_GEOMETRY_H__
